/* 55,6 us/1 .       50 .
8000000   31,7   TOIE0
*/
#define u8 unsigned char
#include <avr/io.h>
#include <stdio.h>
#include <stdbool.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>

#include "def_m8_3.c"
#include "interrups.c"
#include "Func.c"
#include "net.c"


//Macros========================================================================================
//   (  0  )---------------------
//name_var -  ; bef_var -   (bool); 
//result - RLO(bool) (  );
#define	FNvar(name_var,bef_var,result)	do{if(!name_var && bef_var){result=true;\
										}else{result=false;}bef_var=true&&name_var;  }while(0)
//    ---------------------------------------------
//pinx -   ; index -   ; bef_in -  (bool);
//result - RLO(bool);
#define	FPin(pinx,bit,bef_in,result)	do{if((pinx&1<<bit) && !bef_in){result=true;\
										}else{result=false;}bef_in=pinx&1<<bit;  }while(0)
//    -----------------------------------------------
#define FNin(pinx,bit,bef_in,result)	do{if(!(pinx&1<<bit) && bef_in){result=true;\
										}else{result=false;}bef_in=pinx&1<<bit;   }while(0)
//  ----------------------------------------------------------------------
//cond (bool)- (condition)  ; del_puls -   .
//portx -  ; bit -  ; i -   .
#define	OUTctrl(cond,del_puls,portx,bit,i)	do{if(cond){portx|=1<<bit; i=del_puls;}\
											if(i)i--; if(!i)portx&=~(1<<bit);  }while(0)
//------------------------------------------------












//     eeprom----------------------------------------------------


//-------------------------------------------------------------------------------------------
int main(void)// ===============================================================
{
bool bef_delA=0;
bool bef_delB=0;
bool bef_delC=0;
bool bef_delNA=0;
bool bef_delNB=0;
bool bef_delNC=0;

bool rlo_del_A=0;
bool rlo_del_B=0;
bool rlo_del_C=0;
bool rlo_del_NA=0;
bool rlo_del_NB=0;
bool rlo_del_NC=0;

bool bef_inA=0;
bool bef_inB=0;
bool bef_inC=0;
bool bef_inNA=0;
bool bef_inNB=0;
bool bef_inNC=0;

bool rlo_inA=0;
bool rlo_inB=0;
bool rlo_inC=0;
bool rlo_inNA=0;
bool rlo_inNB=0;
bool rlo_inNC=0;


u8 const del_puls=1;
u8	ctrl_reg;
u8 i=0;
u8 SpCtrl;		//  .





TIMSK=1<<TOIE0;
TCCR0=1<<CS00;
//ports.........................
OUTD|=1<<opinA|1<<opinB|1<<opinC|1<<opinNA|1<<opinNB|1<<opinNC;
PORTB|=1<<0|1<<1;

PORTD|=7<<5;

PORTC|=1<<0;

//..............................
/*
int s1=156;
int s2=90;
int	s3=5;

eeprom_write_word(&SPEED1,s1);
eeprom_write_word(&SPEED2,s2);
eeprom_write_word(&SPEED3,s3);
*/

// SRAMchar = eeprom_read_byte(&NonVolatileChar)
speed1 = eeprom_read_byte(&SPEED1);
speed2 = eeprom_read_byte(&SPEED2);
speed3 = eeprom_read_byte(&SPEED3);







asm("sei");
	while(1)//______________  _______________________________________________
	{
// ......................................................................
		SpCtrl=Ispd&(1<<spd1|1<<spd2|1<<spd3);
		switch(SpCtrl)
		{
			case 0:
				goto skip1;

			case 0b00100000:
				ctrl_reg=speed1;
			break;
			case 0b01000000:
				ctrl_reg=speed2;
			break;
			case 0b11000000:
				ctrl_reg=speed3;
			break;
			default:
				goto skip1;
		}
		

//  .........................................................................
		FNvar(del_A,bef_delA,rlo_del_A);
		FPin(INI,inA,bef_inA,rlo_inA);
		if(rlo_inA)del_A=ctrl_reg;
		OUTctrl(rlo_del_A,del_puls,OUTP,opinA,i);
//  ........................................................................
		FNvar(del_B,bef_delB,rlo_del_B);
		FPin(INI,inB,bef_inB,rlo_inB);
		if(rlo_inB)del_B=ctrl_reg;
		OUTctrl(rlo_del_B,del_puls,OUTP,opinB,i);
//  ..........................................................................
		FNvar(del_C,bef_delC,rlo_del_C);
		FPin(INI,inC,bef_inC,rlo_inC);
		if(rlo_inC)del_C=ctrl_reg;
		OUTctrl(rlo_del_C,del_puls,OUTP,opinC,i);
//  NA...........................................................................
		FNvar(del_NA,bef_delNA,rlo_del_NA);
	FNin(INI,inA,bef_inNA,rlo_inNA);
		if(rlo_inNA)del_NA=ctrl_reg;
		OUTctrl(rlo_del_NA,del_puls,OUTP,opinNA,i);
//  NB...........................................................................
		FNvar(del_NB,bef_delNB,rlo_del_NB);
		FNin(INI,inB,bef_inNB,rlo_inNB);
		if(rlo_inNB)del_NB=ctrl_reg;
		OUTctrl(rlo_del_NB,del_puls,OUTP,opinNB,i);
//  NC...........................................................................
		FNvar(del_NC,bef_delNC,rlo_del_NC);
		FNin(INI,inC,bef_inNC,rlo_inNC);
		if(rlo_inNC)del_NC=ctrl_reg;
		OUTctrl(rlo_del_NC,del_puls,OUTP,opinNC,i);
//.......................................
skip1:
		SetSpeed();

send_byte(ctrl_reg);

	

//  ......................................................................
/*		if(!(PINB&1<<0) && !count)
			{if(ctrl_reg<202)ctrl_reg++; count=200;}

		if(!(PINB&1<<1) && !count)
			{if(ctrl_reg>=5)ctrl_reg--; count=200;}

			if(count)
				count--;
		
*/		



asm("nop");
	};//_______________________________________  _____________________________


return 0;
}//  **************************************************************************


















